/* Copyright (c) 2004, Jasper van de Gronde
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided
 * that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above
 *     copyright notice, this list of conditions and the
 *     following disclaimer.
 *  2. Redistributions in binary form must reproduce the
 *     above copyright notice, this list of conditions
 *     and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *  3. Neither the name of the author nor the names of
 *     its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written
 *     permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef RDFDB_UTILS_SOCKETSTREAM_H
#define RDFDB_UTILS_SOCKETSTREAM_H

#ifdef WIN32
typedef unsigned int SOCKET; /* This is not very nice, but including winsock2.h gives problems with some defines, so this is the easy way out. */
#else
typedef int SOCKET;
#endif

typedef struct _socket_stream_t socket_stream_t;
socket_stream_t* new_socket_stream(SOCKET socket, int read_buf_size, int write_buf_size);
void delete_socket_stream(socket_stream_t* socket_stream);

int socket_stream_write(socket_stream_t* socket_stream, const void* data, int data_size);
//int socket_stream_read(socket_stream_t* socket_stream, void* data, int data_capacity);
int socket_stream_flush(socket_stream_t* socket_stream);

int socket_stream_readline(socket_stream_t* socket_stream, void* data, int data_capacity);

#endif/*RDFDB_UTILS_SOCKETSTREAM_H*/

